--*********************************************************************************


--* This file is part of the RIBit Renderman(tm) exporter for max

--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes

--*********************************************************************************


struct s_RIBit_Parameter (
	name, value,
	
	fn write =
	(
		local returnStr = "" as stringStream
		if name != undefined then
			format "%" (s_RIBit_Functions.writeValueByType name) to:returnStr
		if value != undefined then
			format "%" (s_RIBit_Functions.writeValueByType value brackets:true) to:returnStr
		returnStr as string
	
	)
) -- end of s_RIBit_Parameter struct


struct s_RIBit_Option (
	name, 
	params = #(),
	indent = "",
	fileHandle,
	
	
fn addParameter name value =
	(
		append params (s_RIBit_Parameter name value)
	),
		
	fn write =
	(
		if fileHandle != undefined then (
			format "%%" indent name to:fileHandle
			for p in params do 
				format "%" (s_RIBit_Functions.writeValueByType p) to:fileHandle
			format "\n" to:fileHandle
		)
	)
) -- end of s_RIBit_Option srtuct



struct s_RIBit_Attribute (

	name, 
	params = #(),
	indent = "",
	fileHandle,
	
	fn addParameter name value =
	(
		append params (s_RIBit_Parameter name:name value:value)
	),
	
	
	fn write =
	(
		if fileHandle != undefined then (
			format "%Attribute \"%\"" indent name to:fileHandle
			for p in params do 
				format "%" (s_RIBit_Functions.writeValueByType p) to:fileHandle
			format "\n" to:fileHandle
		)
	)
) -- end of s_RIBit_Attribute struct